<?php
/**
 * @file
 * Administration pages for the 'Ctools jump menu style' module.
 */

/**
 * Form builder; Administration page for the 'Ctools jump menu style' module.
 *
 * @ingroup forms
 */
function ctools_jump_menu_style_admin_settings() {
  $form['ctools_jump_menu_style_effect'] = array(
    '#type' => 'select',
    '#title' => t('Effect'),
    '#default_value' => variable_get('ctools_jump_menu_style_effect', ''),
    '#options' => array(
      '' => 'hide / show',
      'slideDown,slideUp' => 'slide up / slide down',
      'fadeIn,fadeOut' => 'fade in / fade out',
    ),
  );

  $form['ctools_jump_menu_style_effect_degrade'] = array(
    '#type' => 'checkbox',
    '#value' => variable_get('ctools_jump_menu_style_effect_degrade', 1),
    '#title' => t('Degrade effect for Internet Explorer 7 and below'),
    '#description' => t('Check to use just hide / show effect for IE7.'),
  );

  $form['ctools_jump_menu_style_show_duration'] = array(
    '#type' => 'select',
    '#title' => t('Show duration'),
    '#default_value' => variable_get('ctools_jump_menu_style_show_duration', ''),
    '#options' => array(
      'slow' => 'slow',
      '' => 'medium',
      'fast' => 'fast',
    ),
  );

  $form['ctools_jump_menu_style_hide_duration'] = array(
    '#type' => 'select',
    '#title' => t('Hide duration'),
    '#default_value' => variable_get('ctools_jump_menu_style_show_duration', ''),
    '#options' => array(
      'slow' => 'slow',
      '' => 'medium',
      'fast' => 'fast',
    ),
  );

  $form['ctools_jump_menu_style_cleanup'] = array(
    '#type' => 'checkbox',
    '#value' => variable_get('ctools_jump_menu_style_cleanup', 1),
    '#title' => t('Cleanup jump menu choices'),
    '#description' => t('Check to cleanup and correct display special characters within group and option labels.'),
  );

  $form['ctools_jump_menu_style_distinct'] = array(
    '#type' => 'checkbox',
    '#value' => variable_get('ctools_jump_menu_style_distinct', 1),
    '#title' => t('Distinct jump menu choices'),
    '#description' => t('Makes sure all display values are distincted.'),
  );

  return system_settings_form($form);
}


/**
 * Form builder; Examples page for the 'Ctools jump menu style' module.
 *
 * @ingroup forms
 */
function ctools_jump_menu_style_examples() {
  ctools_include('jump-menu');

  $targets = array();

  $groups = array(
    'admin/content' => t('Content management'),
    'admin/build' => t('Site building'),
    'admin/settings' => t('Site coonfiguration'),
  );
  foreach ($groups as $path => $title) {
    $mlid = db_result(db_query("SELECT mlid FROM {menu_links} ml WHERE ml.router_path = '%s' AND module = 'system'", $path));

    $result = db_query("SELECT link_path AS href, link_title AS title
      FROM {menu_links}
      WHERE plid LIKE %d
        AND hidden = 0
      ORDER BY weight", $mlid);
    $targets[$title] = array();
    while ($record = db_fetch_array($result)) {
      $targets[$title][ url($record['href']) ] = $record['title'];
    }

  }

  $output = '';

  // Basic
  $element = array(
    '#type' => 'fieldset',
    '#title' => t('Basic example'),
    '#description' => t('Uses basic associative array for targets.'),
    '#value' => drupal_get_form('ctools_jump_menu', $targets[ t('Content management') ], array('choose' => 'Content management...')),
  );
  $output .= theme('fieldset', $element);

  // Advanced
  $element = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced example'),
    '#description' => t('Includes option grouping (ie optgroup) arrays with targets.'),
    '#value' => drupal_get_form('ctools_jump_menu', $targets, array('choose' => 'Administer...')),
  );
  $output .= theme('fieldset', $element);

  return $output;
}