/**
 * @file
 * Add jquery effects to ctools jump menu style.
 */

(function ($) {

// Add ctools-jump-menu-style class to html to enable only for certain devices
if ( !(navigator.userAgent.match(/Android/i) ||
  navigator.userAgent.match(/webOS/i) ||
  navigator.userAgent.match(/iPhone/i) ||
  navigator.userAgent.match(/iPod/i)
  )) {
  $(document.documentElement).addClass('ctools-jump-menu-style');
}

Drupal.behaviors.ctoolsJumpMenuStyle = function (context) {
  $('.ctools-jump-menu:not(.ctoolsJumpMenuStyle-processed)', context).addClass('ctoolsJumpMenuStyle-processed').each(function() {
    var $ctoolsJumpMenu = $(this);

    // IE 7 has problems with effects so just use show and hide if degrade is checked.
    if ($.browser.msie && $.browser.version < 8 && Drupal.settings['ctools_jump_menu_style']['effect_degrade']) {
      var show = 'show';
      var hide = 'hide';
      var show_duration = '';
      var hide_duration = '';
    }
    else {
      var effect = Drupal.settings['ctools_jump_menu_style']['effect'].split(',');
      var show = effect[0] || 'show';
      var hide = effect[1] || 'hide';
      var show_duration = Drupal.settings['ctools_jump_menu_style']['show_duration'];
      var hide_duration = Drupal.settings['ctools_jump_menu_style']['hide_duration'];
    }

    // Fixing IE7 Z-Index Issues with jQuery
    // from: http://www.vancelucas.com/blog/fixing-ie7-z-index-issues-with-jquery/
    if ($.browser.msie && $.browser.version < 8) {
      var zIndex = 1000;
      // Reset all ctools jump menu z-indexes
      $('.ctools-jump-menu').each(function() {
        $(this).css('zIndex', --zIndex);
      });
    }

    $ctoolsJumpMenu.find('.ctools-jump-menu-title').click(function () {
      var $items = $ctoolsJumpMenu.find('.ctools-jump-menu-items');

      // Start to display items.
      $items[show](show_duration);

      // Must set items width after the item is visible.
      var width = $(this).outerWidth() - ($items.outerWidth() - $items.width());
      $items.width( width );

      return false;
    });

    var timer; // Timer is used to track open jump menus.
    $ctoolsJumpMenu.mouseout(function() {
      // Note: Hides all ctools jump menus.
      timer = setTimeout(function(){$('.ctools-jump-menu-items')[hide](hide_duration)}, 500);
    });

    $ctoolsJumpMenu.mouseover(function() {
      clearTimeout(timer);
    });
  });

}

})(jQuery)
